/*
 Corrections:
 14-Dec-98 OC The definition of HFITHN was wrong
 11-Dec-98 OC mods in HUNPAK HUNPKE HREBIN: PFLOAT is now FLOATV
 02-Feb-98 OC mods for HBNAME
 30-Jan-98 OC HID1 HID2 were not correct
 30-Jan-98 OC HRENC added
 15-Feb-94 GF HGIVE  correct output args
              HGIVEN idem
 18-Feb-94 GF comment headers for routines with more than 10 Arguments
              and break long lines by \ (for the VAX)
 -------------above carried over from previous file on 15-Mar-94
 11-Apr-94 GF remove ALL occurences of ZTRING (these are not used so far)
              correct HOPEN, HROUT calls
 21-Apr-94 GF restore PROTOCCALLSFFUNi lines for functions.
 18-May-94 GF correct passing of external functions, must use ROUTINE
 further comments kept in RCS/CVS
 12-Apr-95 GF delete all non documented routines; this should give a more 
              version for this file.
---------------------------------------
*/

#define HARRAY(A1,A2,A3)  CCALLSFSUB3(HARRAY,harray,INT,INT,PINT,A1,A2,A3)
#define HBANDX(A1,A2,A3,A4)  CCALLSFSUB4(HBANDX,hbandx,INT,FLOAT,FLOAT,FLOAT,A1,A2,A3,A4)
#define HBANDY(A1,A2,A3,A4)  CCALLSFSUB4(HBANDY,hbandy,INT,FLOAT,FLOAT,FLOAT,A1,A2,A3,A4)
#define HBARX(A1)  CCALLSFSUB1(HBARX,hbarx,INT,A1)
#define HBARY(A1)  CCALLSFSUB1(HBARY,hbary,INT,A1)
#define HBFUN1(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HBFUN1,hbfun1,INT,STRING,INT,FLOAT,FLOAT,ROUTINE,A1,A2,A3,A4,A5,A6)
#define HBFUN2(A1,A2,A3,A4,A5,A6,A7,A8,A9)  CCALLSFSUB9(HBFUN2,hbfun2,INT,STRING,INT,FLOAT,FLOAT,INT,FLOAT,FLOAT,ROUTINE,A1,A2,A3,A4,A5,A6,A7,A8,A9)
#define HBIGBI(A1,A2)  CCALLSFSUB2(HBIGBI,hbigbi,INT,INT,A1,A2)
#define HBINSZ(A1)  CCALLSFSUB1(HBINSZ,hbinsz,STRING,A1)

#define HBNAMC(A1,A2,A3,A4)  CCALLSFSUB4(HBNAMC,hbnamc,INT,STRING,PSTRINGV,STRING,A1,A2,A3,A4)

#ifndef PSTRUCT_cfV
#define PSTRUCT_cfV(  T,A,B,F)       SIMPLE_cfV(T,A,B,F)
#define PSTRUCT_cfSEP(T,  B)         SIMPLE_cfSEP(T,B)
#define PSTRUCT_cfINT(N,A,B,X,Y,Z)   SIMPLE_cfINT(N,A,B,X,Y,Z)
#define PSTRUCT_cfSTR(N,T,A,B,C,D,E) SIMPLE_cfSTR(N,T,A,B,C,D,E)
#define PSTRUCT_cfCC( T,A,B)         SIMPLE_cfCC(T,A,B)
#define PSTRUCT_cfAA( T,A,B)         PSTRUCT_cfB(T,A)   /* Argument B not used. */
#define PSTRUCT_cfU(  T,A)         PSTRUCT_cfN(T,A)
#define PSTRUCT_cfN(  T,A)        void *A
#define PSTRUCT_cfB(  T,A)       (void *) &(A)
#endif
#define HBNAME(A1,A2,A3,A4) CCALLSFSUB4(HBNAME,hbname,INT,STRING,PSTRUCT,STRING,A1,A2,A3,A4)

#define HBNT(A1,A2,A3)  CCALLSFSUB3(HBNT,hbnt,INT,STRING,STRING,A1,A2,A3)
#define HBOOKB(A1,A2,A3,A4,A5)  CCALLSFSUB5(HBOOKB,hbookb,INT,STRING,INT,FLOATV,FLOAT,A1,A2,A3,A4,A5)
#define HBOOKN(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HBOOKN,hbookn,INT,STRING,INT,STRING,INT,STRINGV,A1,A2,A3,A4,A5,A6)
#define HBOOK1(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HBOOK1,hbook1,INT,STRING,INT,FLOAT,FLOAT,FLOAT,A1,A2,A3,A4,A5,A6)
#define HBOOK2(A1,A2,A3,A4,A5,A6,A7,A8,A9)  CCALLSFSUB9(HBOOK2,hbook2,INT,STRING,INT,FLOAT,FLOAT,INT,FLOAT,FLOAT,FLOAT,A1,A2,A3,A4,A5,A6,A7,A8,A9)
#define HBPRO(A1,A2)  CCALLSFSUB2(HBPRO,hbpro,INT,FLOAT,A1,A2)
#define HBPROF(A1,A2,A3,A4,A5,A6,A7,A8)  CCALLSFSUB8(HBPROF,hbprof,INT,STRING,INT,FLOAT,FLOAT,FLOAT,FLOAT,STRING,A1,A2,A3,A4,A5,A6,A7,A8)
#define HBPROX(A1,A2)  CCALLSFSUB2(HBPROX,hbprox,INT,FLOAT,A1,A2)
#define HBPROY(A1,A2)  CCALLSFSUB2(HBPROY,hbproy,INT,FLOAT,A1,A2)
#define HBSET(A1,A2,A3)  CCALLSFSUB3(HBSET,hbset,STRING,INT,PINT,A1,A2,A3)
#define HBSLIX(A1,A2,A3)  CCALLSFSUB3(HBSLIX,hbslix,INT,INT,FLOAT,A1,A2,A3)
#define HBSLIY(A1,A2,A3)  CCALLSFSUB3(HBSLIY,hbsliy,INT,INT,FLOAT,A1,A2,A3)
#define HCDIR(A1,A2)  CCALLSFSUB2(HCDIR,hcdir,PSTRING,STRING,A1,A2)
#define HCOMPA(A1,A2)  CCALLSFSUB2(HCOMPA,hcompa,INTV,INT,A1,A2)
#define HCOPY(A1,A2,A3)  CCALLSFSUB3(HCOPY,hcopy,INT,INT,STRING,A1,A2,A3)
#define HCOPYM(A1,A2,A3)  CCALLSFSUB3(HCOPYM,hcopym,INT,INTV,INT,A1,A2,A3)
#define HDELET(A1)  CCALLSFSUB1(HDELET,hdelet,INT,A1)
#define HDERIV(A1)  CCALLSFSUB1(HDERIV,hderiv,FLOATV,A1)
#define HDIFF(A1,A2,A3,A4)  CCALLSFSUB4(HDIFF,hdiff,INT,INT,PFLOAT,STRING,A1,A2,A3,A4)
#define HDIFFB(A1,A2,A3,A4,A5,A6,A7)  CCALLSFSUB7(HDIFFB,hdiffb,INT,INT,FLOAT,INT,STRING,INT,FLOATV,A1,A2,A3,A4,A5,A6,A7)
#define HDUMP(A1)  CCALLSFSUB1(HDUMP,hdump,INT,A1)
#define HERMES(A1)  CCALLSFSUB1(HERMES,hermes,INT,A1)
#define HFC2(A1,A2,A3,A4,A5,A6,A7)  CCALLSFSUB7(HFC2,hfc2,INT,INT,STRING,INT,STRING,FLOAT,STRING,A1,A2,A3,A4,A5,A6,A7)
#define HFF1(A1,A2,A3,A4)  CCALLSFSUB4(HFF1,hff1,INT,PINT,FLOAT,FLOAT,A1,A2,A3,A4)
#define HFF2(A1,A2,A3,A4,A5)  CCALLSFSUB5(HFF2,hff2,INT,PINT,FLOAT,FLOAT,FLOAT,A1,A2,A3,A4,A5)
#define HFILL(A1,A2,A3,A4)  CCALLSFSUB4(HFILL,hfill,INT,FLOAT,FLOAT,FLOAT,A1,A2,A3,A4)
#define HFINAM(A1,A2,A3)  CCALLSFSUB3(HFINAM,hfinam,INT,STRINGV,INT,A1,A2,A3)
#define HFITEX(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HFITEX,hfitex,INT,PFLOAT,PFLOAT,PFLOAT,INT,FLOATV,A1,A2,A3,A4,A5,A6)
#define HFITGA(A1,A2,A3,A4,A5,A6,A7)  CCALLSFSUB7(HFITGA,hfitga,INT,PFLOAT,PFLOAT,PFLOAT,PFLOAT,INT,FLOATV,A1,A2,A3,A4,A5,A6,A7)
#define HFITH(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)  CCALLSFSUB10(HFITH,hfith,INT,ROUTINE,STRING,INT,FLOATV,FLOATV,FLOATV,FLOATV,FLOATV,PFLOAT,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)
#define HFITHN(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)  CCALLSFSUB10(HFITHN,hfithn,INT,STRING,STRING,INT,FLOATV,FLOATV,FLOATV,FLOATV,FLOATV,PFLOAT,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)
#define HFITL(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11)  CCALLSFSUB11(HFITL,hfitl,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT,PFLOAT,FLOATV,FLOATV,FLOATV,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11)
#define HFITN(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,A15,A16)  CCALLSFSUB16(HFITN,hfitn,PFLOAT,FLOATV,FLOATV,INT,INT,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT,PFLOAT,FLOATV,FLOATV,FLOATV,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,A15,A16)
#define HFITPO(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HFITPO,hfitpo,INT,INT,FLOATV,PFLOAT,INT,FLOATV,A1,A2,A3,A4,A5,A6)
#define HFITS(A1,A2,A3,A4,A5,A6,A7)  CCALLSFSUB7(HFITS,hfits,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT,A1,A2,A3,A4,A5,A6,A7)
#define HFITV(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,A15)  CCALLSFSUB15(HFITV,hfitv,INT,INT,INT,PFLOAT,FLOATV,FLOATV,ROUTINE,STRING,INT,FLOATV,FLOATV,FLOATV,FLOATV,PFLOAT,PFLOAT,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,A15)
#define HFIT1(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)  CCALLSFSUB10(HFIT1,hfit1,FLOATV,FLOATV,FLOATV,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)
#define HFN(A1,A2)  CCALLSFSUB2(HFN,hfn,INT,FLOATV,A1,A2)
#define HFNT(A1)  CCALLSFSUB1(HFNT,hfnt,INT,A1)
#define HFNTB(A1,A2)  CCALLSFSUB2(HFNTB,hfntb,INT,STRING,A1,A2)
#define HFPAK1(A1,A2,A3,A4)  CCALLSFSUB4(HFPAK1,hfpak1,INT,PINT,FLOATV,INT,A1,A2,A3,A4)
#define HFUNC(A1,A2)  CCALLSFSUB2(HFUNC,hfunc,INT,ROUTINE,A1,A2)
#define HF1(A1,A2,A3)  CCALLSFSUB3(HF1,hf1,INT,FLOAT,FLOAT,A1,A2,A3)
#define HF2(A1,A2,A3,A4)  CCALLSFSUB4(HF2,hf2,INT,FLOAT,FLOAT,FLOAT,A1,A2,A3,A4)
#define HGFIT(A1,A2,A3,A4,A5,A6,A7)  CCALLSFSUB7(HGFIT,hgfit,INT,PINT,PINT,PFLOAT,PFLOAT,PFLOAT,PSTRINGV,A1,A2,A3,A4,A5,A6,A7)
#define HGIVE(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)  CCALLSFSUB10(HGIVE,hgive,INT,STRING,PINT,PFLOAT,PFLOAT,PINT,PFLOAT,PFLOAT,PINT,PINT,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10)
#define HGIVEN(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HGIVEN,hgiven,INT,PSTRING,PINT,PSTRINGV,PFLOAT,PFLOAT,A1,A2,A3,A4,A5,A6)
#define HGN(A1,A2,A3,A4,A5)  CCALLSFSUB5(HGN,hgn,INT,PINT,INT,PFLOAT,PINT,A1,A2,A3,A4,A5)
#define HGNF(A1,A2,A3,A4)  CCALLSFSUB4(HGNF,hgnf,INT,INT,PFLOAT,PINT,A1,A2,A3,A4)
#define HGNPAR(A1,A2)  CCALLSFSUB2(HGNPAR,hgnpar,INT,STRING,A1,A2)
#define HGNT(A1,A2,A3)  CCALLSFSUB3(HGNT,hgnt,INT,INT,INT,A1,A2,A3)
#define HGNTB(A1,A2,A3,A4)  CCALLSFSUB4(HGNTB,hgntb,INT,STRING,INT,INT,A1,A2,A3,A4)
#define HGNTF(A1,A2,A3)  CCALLSFSUB3(HGNTF,hgntf,INT,INT,PINT,A1,A2,A3)
#define HGNTV(A1,A2,A3,A4,A5)  CCALLSFSUB5(HGNTV,hgntv,INT,STRINGV,INT,INT,INT,A1,A2,A3,A4,A5)
#define HIDALL(A1,A2)  CCALLSFSUB2(HIDALL,hidall,INTV,PINT,A1,A2)
#define HIDOPT(A1,A2)  CCALLSFSUB2(HIDOPT,hidopt,INT,STRING,A1,A2)
#define HID1(A1,A2)  CCALLSFSUB2(HID1,hid1,INTV,PINT,A1,A2)
#define HID2(A1,A2)  CCALLSFSUB2(HID2,hid2,INTV,PINT,A1,A2)
#define HIJXY(A1,A2,A3,A4,A5)  CCALLSFSUB5(HIJXY,hijxy,INT,INT,INT,PFLOAT,PFLOAT,A1,A2,A3,A4,A5)
#define HINDEX() CCALLSFSUB0(HINDEX,hindex)
#define HIPAK1(A1,A2,A3,A4)  CCALLSFSUB4(HIPAK1,hipak1,INT,PINT,INTV,INT,A1,A2,A3,A4)
#define HISTDO() CCALLSFSUB0(HISTDO,histdo)
#define HIX(A1,A2,A3)  CCALLSFSUB3(HIX,hix,INT,INT,PFLOAT,A1,A2,A3)
#define HLABEL(A1,A2,A3,A4)  CCALLSFSUB4(HLABEL,hlabel,INT,INT,STRINGV,STRING,A1,A2,A3,A4)
#define HLDIR(A1,A2)  CCALLSFSUB2(HLDIR,hldir,STRING,STRING,A1,A2)
#define HLIMAP(A1,A2)  CCALLSFSUB2(HLIMAP,hlimap,INT,STRING,A1,A2)
#define HLIMIT(A1)  CCALLSFSUB1(HLIMIT,hlimit,INT,A1)
#define HLNEXT(A1,A2,A3,A4)  CCALLSFSUB4(HLNEXT,hlnext,PINT,PSTRING,PSTRING,STRING,A1,A2,A3,A4)
#define HLOCAT(A1,A2)  CCALLSFSUB2(HLOCAT,hlocat,INT,PINT,A1,A2)
#define HMAXIM(A1,A2)  CCALLSFSUB2(HMAXIM,hmaxim,INT,FLOAT,A1,A2)
#define HMDIR(A1,A2)  CCALLSFSUB2(HMDIR,hmdir,STRING,STRING,A1,A2)
#define HMINIM(A1,A2)  CCALLSFSUB2(HMINIM,hminim,INT,FLOAT,A1,A2)
#define HNOENT(A1,A2)  CCALLSFSUB2(HNOENT,hnoent,INT,PINT,A1,A2)
#define HNORMA(A1,A2)  CCALLSFSUB2(HNORMA,hnorma,INT,FLOAT,A1,A2)
#define HOPERA(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HOPERA,hopera,INT,STRING,INT,INT,FLOAT,FLOAT,A1,A2,A3,A4,A5,A6)
#define HOUTPU(A1)  CCALLSFSUB1(HOUTPU,houtpu,INT,A1)
#define HPAGSZ(A1)  CCALLSFSUB1(HPAGSZ,hpagsz,INT,A1)
#define HPAK(A1,A2)  CCALLSFSUB2(HPAK,hpak,INT,FLOATV,A1,A2)
#define HPAKAD(A1,A2)  CCALLSFSUB2(HPAKAD,hpakad,INT,FLOATV,A1,A2)
#define HPAKE(A1,A2)  CCALLSFSUB2(HPAKE,hpake,INT,FLOATV,A1,A2)
#define HPARAM(A1,A2,A3,A4,A5,A6,A7)  CCALLSFSUB7(HPARAM,hparam,INT,INT,FLOAT,INTV,PDOUBLE,PINT,PINT,A1,A2,A3,A4,A5,A6,A7)
#define HPARMN(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11)  CCALLSFSUB11(HPARMN,hparmn,PFLOAT,FLOATV,FLOATV,INT,INT,INT,FLOAT,INTV,PDOUBLE,PINT,PINT,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11)
#define HPCHAR(A1,A2)  CCALLSFSUB2(HPCHAR,hpchar,INTV,INTV,A1,A2)
#define HPDIR(A1,A2)  CCALLSFSUB2(HPDIR,hpdir,STRING,STRING,A1,A2)
#define HPHIST(A1,A2,A3)  CCALLSFSUB3(HPHIST,hphist,INT,STRING,INT,A1,A2,A3)
#define HPHS(A1)  CCALLSFSUB1(HPHS,hphs,INT,A1)
#define HPHST(A1)  CCALLSFSUB1(HPHST,hphst,INT,A1)
#define HPONCE() CCALLSFSUB0(HPONCE,hponce)
#define HPRINT(A1)  CCALLSFSUB1(HPRINT,hprint,INT,A1)
#define HPRNT(A1)  CCALLSFSUB1(HPRNT,hprnt,INT,A1)
#define HPROJ1(A1,A2,A3,A4,A5,A6,A7)  CCALLSFSUB7(HPROJ1,hproj1,INT,INT,INT,ROUTINE,INT,INT,INT,A1,A2,A3,A4,A5,A6,A7)
#define HPROJ2(A1,A2,A3,A4,A5,A6,A7,A8)  CCALLSFSUB8(HPROJ2,hproj2,INT,INT,INT,ROUTINE,INT,INT,INT,INT,A1,A2,A3,A4,A5,A6,A7,A8)
#define HPROT(A1,A2,A3)  CCALLSFSUB3(HPROT,hprot,INT,STRING,INT,A1,A2,A3)
#define HPSCAT(A1)  CCALLSFSUB1(HPSCAT,hpscat,INT,A1)
#define HPTAB(A1)  CCALLSFSUB1(HPTAB,hptab,INT,A1)
#define HQUAD(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11)  CCALLSFSUB11(HQUAD,hquad,INT,STRING,INT,FLOAT,FLOAT,PINT,PFLOAT,PINT,PFLOAT,PFLOAT,PINT,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11)
#define HRDIR(A1,A2,A3)  CCALLSFSUB3(HRDIR,hrdir,INT,PSTRINGV,PINT,A1,A2,A3)
#define HREBIN(A1,A2,A3,A4,A5,A6,A7,A8)  CCALLSFSUB8(HREBIN,hrebin,INT,FLOATV,FLOATV,FLOATV,FLOATV,INT,INT,INT,A1,A2,A3,A4,A5,A6,A7,A8)
#define HRECOV(A1,A2)  CCALLSFSUB2(HRECOV,hrecov,INT,STRING,A1,A2)
#define HREND(A1)  CCALLSFSUB1(HREND,hrend,STRING,A1)
#define HRENDC(A1)  CCALLSFSUB1(HRENDC,hrendc,STRING,A1)
#define HRESET(A1,A2)  CCALLSFSUB2(HRESET,hreset,INT,STRING,A1,A2)
#define HRFILE(A1,A2,A3)  CCALLSFSUB3(HRFILE,hrfile,INT,STRING,STRING,A1,A2,A3)
#define HRGET(A1,A2,A3)  CCALLSFSUB3(HRGET,hrget,INT,STRING,STRING,A1,A2,A3)
#define HRIN(A1,A2,A3)  CCALLSFSUB3(HRIN,hrin,INT,INT,INT,A1,A2,A3)
#define HRNDM2(A1,A2,A3)  CCALLSFSUB3(HRNDM2,hrndm2,INT,PFLOAT,PFLOAT,A1,A2,A3)
#define HROPEN(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(HROPEN,hropen,INT,STRING,STRING,STRING,PINT,PINT,A1,A2,A3,A4,A5,A6)
#define HROUT(A1,A2,A3)  CCALLSFSUB3(HROUT,hrout,INT,PINT,STRING,A1,A2,A3)
#define HRPUT(A1,A2,A3)  CCALLSFSUB3(HRPUT,hrput,INT,STRING,STRING,A1,A2,A3)
#define HSCALE(A1,A2)  CCALLSFSUB2(HSCALE,hscale,INT,FLOAT,A1,A2)
#define HSCR(A1,A2,A3)  CCALLSFSUB3(HSCR,hscr,INT,INT,STRING,A1,A2,A3)
#define HSETPR(A1,A2)  CCALLSFSUB2(HSETPR,hsetpr,STRING,FLOAT,A1,A2)
#define HSMOOF(A1,A2,A3)  CCALLSFSUB3(HSMOOF,hsmoof,INT,INT,FLOAT,A1,A2,A3)
#define HSPLI1(A1,A2,A3,A4,A5)  CCALLSFSUB5(HSPLI1,hspli1,INT,INT,INT,INT,PFLOAT,A1,A2,A3,A4,A5)
#define HSPLI2(A1,A2,A3,A4,A5)  CCALLSFSUB5(HSPLI2,hspli2,INT,INT,INT,INT,INT,A1,A2,A3,A4,A5)
#define HSQUEZ(A1)  CCALLSFSUB1(HSQUEZ,hsquez,STRING,A1)
#define HTITLE(A1)  CCALLSFSUB1(HTITLE,htitle,STRING,A1)
#define HUNPAK(A1,A2,A3,A4)  CCALLSFSUB4(HUNPAK,hunpak,INT,FLOATV,STRING,INT,A1,A2,A3,A4)
#define HUNPKE(A1,A2,A3,A4)  CCALLSFSUB4(HUNPKE,hunpke,INT,FLOATV,STRING,INT,A1,A2,A3,A4)
#define HUWFUN(A1,A2,A3,A4,A5)  CCALLSFSUB5(HUWFUN,huwfun,INT,INT,STRING,INT,STRING,A1,A2,A3,A4,A5)
#define HXI(A1,A2,A3)  CCALLSFSUB3(HXI,hxi,INT,FLOAT,PINT,A1,A2,A3)
#define HXYIJ(A1,A2,A3,A4,A5)  CCALLSFSUB5(HXYIJ,hxyij,INT,FLOAT,FLOAT,PINT,PINT,A1,A2,A3,A4,A5)
#define HEXIST(A2)  CCALLSFFUN1(HEXIST,hexist,INT,A2)
#define HI(A2,A3)  CCALLSFFUN2(HI,hi,INT,INT,A2,A3)
#define HIE(A2,A3)  CCALLSFFUN2(HIE,hie,INT,INT,A2,A3)
#define HIF(A2,A3)  CCALLSFFUN2(HIF,hif,INT,INT,A2,A3)
#define HIJ(A2,A3,A4)  CCALLSFFUN3(HIJ,hij,INT,INT,INT,A2,A3,A4)
#define HMAX(A2)  CCALLSFFUN1(HMAX,hmax,INT,A2)
#define HMIN(A2)  CCALLSFFUN1(HMIN,hmin,INT,A2)
#define HRNDM1(A2)  CCALLSFFUN1(HRNDM1,hrndm1,INT,A2)
#define HSPFUN(A2,A3,A4,A5)  CCALLSFFUN4(HSPFUN,hspfun,INT,FLOAT,INT,INT,A2,A3,A4,A5)
#define HSTATI(A2,A3,A4,A5)  CCALLSFFUN4(HSTATI,hstati,INT,INT,STRING,INT,A2,A3,A4,A5)
#define HSUM(A2)  CCALLSFFUN1(HSUM,hsum,INT,A2)
#define HX(A2,A3)  CCALLSFFUN2(HX,hx,INT,FLOAT,A2,A3)
#define HXE(A2,A3)  CCALLSFFUN2(HXE,hxe,INT,FLOAT,A2,A3)
#define HXY(A2,A3,A4)  CCALLSFFUN3(HXY,hxy,INT,FLOAT,FLOAT,A2,A3,A4)

#if defined(vms) || defined(__vms)

#define HCREATEG(A2,A3,A4)  CCALLSFFUN3(HCREATEG,hcreateg,STRING,PINT,INT,A2,A3,A4)
 /* last arg in hmapg (offset) is output, contrary to my version of the manual*/
#define HMAPG(A2,A3,A4)  CCALLSFFUN3(HMAPG,hmapg,STRING,PINT,PINT,A2,A3,A4)

#else

#define HLIMAP(A1,A2)  CCALLSFSUB2(HLIMAP,hlimap,INT,STRING,A1,A2)

#endif

/* function protypes follow */
PROTOCCALLSFSUB3(HARRAY,harray,INT,INT,PINT)
PROTOCCALLSFSUB4(HBANDX,hbandx,INT,FLOAT,FLOAT,FLOAT)
PROTOCCALLSFSUB4(HBANDY,hbandy,INT,FLOAT,FLOAT,FLOAT)
PROTOCCALLSFSUB1(HBARX,hbarx,INT)
PROTOCCALLSFSUB1(HBARY,hbary,INT)
PROTOCCALLSFSUB6(HBFUN1,hbfun1,INT,STRING,INT,FLOAT,FLOAT,ROUTINE)
PROTOCCALLSFSUB9(HBFUN2,hbfun2,INT,STRING,INT,FLOAT,FLOAT,INT,FLOAT,FLOAT,ROUTINE)
PROTOCCALLSFSUB2(HBIGBI,hbigbi,INT,INT)
PROTOCCALLSFSUB1(HBINSZ,hbinsz,STRING)

PROTOCCALLSFSUB4(HBNAMC,hbnamc,INT,STRING,PSTRINGV,STRING)

PROTOCCALLSFSUB4(HBNAME,hbname,INT,STRING,PSTRUCT,STRING)

PROTOCCALLSFSUB3(HBNT,hbnt,INT,STRING,STRING)
PROTOCCALLSFSUB5(HBOOKB,hbookb,INT,STRING,INT,FLOATV,FLOAT)
PROTOCCALLSFSUB6(HBOOKN,hbookn,INT,STRING,INT,STRING,INT,STRINGV)
PROTOCCALLSFSUB6(HBOOK1,hbook1,INT,STRING,INT,FLOAT,FLOAT,FLOAT)
PROTOCCALLSFSUB9(HBOOK2,hbook2,INT,STRING,INT,FLOAT,FLOAT,INT,FLOAT,FLOAT,FLOAT)
PROTOCCALLSFSUB2(HBPRO,hbpro,INT,FLOAT)
PROTOCCALLSFSUB8(HBPROF,hbprof,INT,STRING,INT,FLOAT,FLOAT,FLOAT,FLOAT,STRING)
PROTOCCALLSFSUB2(HBPROX,hbprox,INT,FLOAT)
PROTOCCALLSFSUB2(HBPROY,hbproy,INT,FLOAT)
PROTOCCALLSFSUB3(HBSET,hbset,STRING,INT,PINT)
PROTOCCALLSFSUB3(HBSLIX,hbslix,INT,INT,FLOAT)
PROTOCCALLSFSUB3(HBSLIY,hbsliy,INT,INT,FLOAT)
PROTOCCALLSFSUB2(HCDIR,hcdir,PSTRING,STRING)
PROTOCCALLSFSUB2(HCOMPA,hcompa,INTV,INT)
PROTOCCALLSFSUB3(HCOPY,hcopy,INT,INT,STRING)
PROTOCCALLSFSUB3(HCOPYM,hcopym,INT,INTV,INT)
PROTOCCALLSFSUB1(HDELET,hdelet,INT)
PROTOCCALLSFSUB1(HDERIV,hderiv,FLOATV)
PROTOCCALLSFSUB4(HDIFF,hdiff,INT,INT,PFLOAT,STRING)
PROTOCCALLSFSUB7(HDIFFB,hdiffb,INT,INT,FLOAT,INT,STRING,INT,FLOATV)
PROTOCCALLSFSUB1(HDUMP,hdump,INT)
PROTOCCALLSFSUB1(HERMES,hermes,INT)
PROTOCCALLSFSUB7(HFC2,hfc2,INT,INT,STRING,INT,STRING,FLOAT,STRING)
PROTOCCALLSFSUB4(HFF1,hff1,INT,PINT,FLOAT,FLOAT)
PROTOCCALLSFSUB5(HFF2,hff2,INT,PINT,FLOAT,FLOAT,FLOAT)
PROTOCCALLSFSUB4(HFILL,hfill,INT,FLOAT,FLOAT,FLOAT)
PROTOCCALLSFSUB3(HFINAM,hfinam,INT,STRINGV,INT)
PROTOCCALLSFSUB6(HFITEX,hfitex,INT,PFLOAT,PFLOAT,PFLOAT,INT,FLOATV)
PROTOCCALLSFSUB7(HFITGA,hfitga,INT,PFLOAT,PFLOAT,PFLOAT,PFLOAT,INT,FLOATV)
PROTOCCALLSFSUB10(HFITH,hfith,INT,ROUTINE,STRING,INT,FLOATV,FLOATV,FLOATV,FLOATV,FLOATV,PFLOAT)
PROTOCCALLSFSUB10(HFITHN,hfithn,INT,STRING,STRING,INT,FLOATV,FLOATV,FLOATV,FLOATV,FLOATV,PFLOAT)
PROTOCCALLSFSUB11(HFITL,hfitl,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT,PFLOAT,FLOATV,FLOATV,FLOATV)
PROTOCCALLSFSUB16(HFITN,hfitn,PFLOAT,FLOATV,FLOATV,INT,INT,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT,PFLOAT,FLOATV,FLOATV,FLOATV)
PROTOCCALLSFSUB6(HFITPO,hfitpo,INT,INT,FLOATV,PFLOAT,INT,FLOATV)
PROTOCCALLSFSUB7(HFITS,hfits,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT)
PROTOCCALLSFSUB15(HFITV,hfitv,INT,INT,INT,PFLOAT,FLOATV,FLOATV,ROUTINE,STRING,INT,FLOATV,FLOATV,FLOATV,FLOATV,PFLOAT,PFLOAT)
PROTOCCALLSFSUB10(HFIT1,hfit1,FLOATV,FLOATV,FLOATV,INT,ROUTINE,INT,DOUBLEV,PFLOAT,INT,PFLOAT)
PROTOCCALLSFSUB2(HFN,hfn,INT,FLOATV)
PROTOCCALLSFSUB1(HFNT,hfnt,INT)
PROTOCCALLSFSUB2(HFNTB,hfntb,INT,STRING)
PROTOCCALLSFSUB4(HFPAK1,hfpak1,INT,PINT,FLOATV,INT)
PROTOCCALLSFSUB2(HFUNC,hfunc,INT,ROUTINE)
PROTOCCALLSFSUB3(HF1,hf1,INT,FLOAT,FLOAT)
PROTOCCALLSFSUB4(HF2,hf2,INT,FLOAT,FLOAT,FLOAT)
PROTOCCALLSFSUB7(HGFIT,hgfit,INT,PINT,PINT,PFLOAT,PFLOAT,PFLOAT,PSTRINGV)
PROTOCCALLSFSUB10(HGIVE,hgive,INT,STRING,PINT,PFLOAT,PFLOAT,PINT,PFLOAT,PFLOAT,PINT,PINT)
PROTOCCALLSFSUB6(HGIVEN,hgiven,INT,PSTRING,PINT,PSTRINGV,PFLOAT,PFLOAT)
PROTOCCALLSFSUB5(HGN,hgn,INT,PINT,INT,PFLOAT,PINT)
PROTOCCALLSFSUB4(HGNF,hgnf,INT,INT,PFLOAT,PINT)
PROTOCCALLSFSUB2(HGNPAR,hgnpar,INT,STRING)
PROTOCCALLSFSUB3(HGNT,hgnt,INT,INT,INT)
PROTOCCALLSFSUB4(HGNTB,hgntb,INT,STRING,INT,INT)
PROTOCCALLSFSUB3(HGNTF,hgntf,INT,INT,PINT)
PROTOCCALLSFSUB5(HGNTV,hgntv,INT,STRINGV,INT,INT,INT)
PROTOCCALLSFSUB2(HIDALL,hidall,INTV,PINT)
PROTOCCALLSFSUB2(HIDOPT,hidopt,INT,STRING)
PROTOCCALLSFSUB2(HID1,hid1,INTV,PINT)
PROTOCCALLSFSUB2(HID2,hid2,INTV,PINT)
PROTOCCALLSFSUB5(HIJXY,hijxy,INT,INT,INT,PFLOAT,PFLOAT)
PROTOCCALLSFSUB0(HINDEX,hindex)
PROTOCCALLSFSUB4(HIPAK1,hipak1,INT,PINT,INTV,INT)
PROTOCCALLSFSUB0(HISTDO,histdo)
PROTOCCALLSFSUB3(HIX,hix,INT,INT,PFLOAT)
PROTOCCALLSFSUB4(HLABEL,hlabel,INT,INT,STRINGV,STRING)
PROTOCCALLSFSUB2(HLDIR,hldir,STRING,STRING)
PROTOCCALLSFSUB2(HLIMAP,hlimap,INT,STRING)
PROTOCCALLSFSUB1(HLIMIT,hlimit,INT)
PROTOCCALLSFSUB4(HLNEXT,hlnext,PINT,PSTRING,PSTRING,STRING)
PROTOCCALLSFSUB2(HLOCAT,hlocat,INT,PINT)
PROTOCCALLSFSUB2(HMAXIM,hmaxim,INT,FLOAT)
PROTOCCALLSFSUB2(HMDIR,hmdir,STRING,STRING)
PROTOCCALLSFSUB2(HMINIM,hminim,INT,FLOAT)
PROTOCCALLSFSUB2(HNOENT,hnoent,INT,PINT)
PROTOCCALLSFSUB2(HNORMA,hnorma,INT,FLOAT)
PROTOCCALLSFSUB6(HOPERA,hopera,INT,STRING,INT,INT,FLOAT,FLOAT)
PROTOCCALLSFSUB1(HOUTPU,houtpu,INT)
PROTOCCALLSFSUB1(HPAGSZ,hpagsz,INT)
PROTOCCALLSFSUB2(HPAK,hpak,INT,FLOATV)
PROTOCCALLSFSUB2(HPAKAD,hpakad,INT,FLOATV)
PROTOCCALLSFSUB2(HPAKE,hpake,INT,FLOATV)
PROTOCCALLSFSUB7(HPARAM,hparam,INT,INT,FLOAT,INTV,PDOUBLE,PINT,PINT)
PROTOCCALLSFSUB11(HPARMN,hparmn,PFLOAT,FLOATV,FLOATV,INT,INT,INT,FLOAT,INTV,PDOUBLE,PINT,PINT)
PROTOCCALLSFSUB2(HPCHAR,hpchar,INTV,INTV)
PROTOCCALLSFSUB2(HPDIR,hpdir,STRING,STRING)
PROTOCCALLSFSUB3(HPHIST,hphist,INT,STRING,INT)
PROTOCCALLSFSUB1(HPHS,hphs,INT)
PROTOCCALLSFSUB1(HPHST,hphst,INT)
PROTOCCALLSFSUB0(HPONCE,hponce)
PROTOCCALLSFSUB1(HPRINT,hprint,INT)
PROTOCCALLSFSUB1(HPRNT,hprnt,INT)
PROTOCCALLSFSUB7(HPROJ1,hproj1,INT,INT,INT,ROUTINE,INT,INT,INT)
PROTOCCALLSFSUB8(HPROJ2,hproj2,INT,INT,INT,ROUTINE,INT,INT,INT,INT)
PROTOCCALLSFSUB3(HPROT,hprot,INT,STRING,INT)
PROTOCCALLSFSUB1(HPSCAT,hpscat,INT)
PROTOCCALLSFSUB1(HPTAB,hptab,INT)
PROTOCCALLSFSUB11(HQUAD,hquad,INT,STRING,INT,FLOAT,FLOAT,PINT,PFLOAT,PINT,PFLOAT,PFLOAT,PINT)
PROTOCCALLSFSUB3(HRDIR,hrdir,INT,PSTRINGV,PINT)
PROTOCCALLSFSUB8(HREBIN,hrebin,INT,FLOATV,FLOATV,FLOATV,FLOATV,INT,INT,INT)
PROTOCCALLSFSUB2(HRECOV,hrecov,INT,STRING)
PROTOCCALLSFSUB1(HREND,hrend,STRING)
PROTOCCALLSFSUB1(HRENDC,hrendc,STRING)
PROTOCCALLSFSUB2(HRESET,hreset,INT,STRING)
PROTOCCALLSFSUB3(HRFILE,hrfile,INT,STRING,STRING)
PROTOCCALLSFSUB3(HRGET,hrget,INT,STRING,STRING)
PROTOCCALLSFSUB3(HRIN,hrin,INT,INT,INT)
PROTOCCALLSFSUB3(HRNDM2,hrndm2,INT,PFLOAT,PFLOAT)
PROTOCCALLSFSUB6(HROPEN,hropen,INT,STRING,STRING,STRING,PINT,PINT)
PROTOCCALLSFSUB3(HROUT,hrout,INT,PINT,STRING)
PROTOCCALLSFSUB3(HRPUT,hrput,INT,STRING,STRING)
PROTOCCALLSFSUB2(HSCALE,hscale,INT,FLOAT)
PROTOCCALLSFSUB3(HSCR,hscr,INT,INT,STRING)
PROTOCCALLSFSUB2(HSETPR,hsetpr,STRING,FLOAT)
PROTOCCALLSFSUB3(HSMOOF,hsmoof,INT,INT,FLOAT)
PROTOCCALLSFSUB5(HSPLI1,hspli1,INT,INT,INT,INT,PFLOAT)
PROTOCCALLSFSUB5(HSPLI2,hspli2,INT,INT,INT,INT,INT)
PROTOCCALLSFSUB1(HSQUEZ,hsquez,STRING)
PROTOCCALLSFSUB1(HTITLE,htitle,STRING)
PROTOCCALLSFSUB4(HUNPAK,hunpak,INT,FLOATV,STRING,INT)
PROTOCCALLSFSUB4(HUNPKE,hunpke,INT,FLOATV,STRING,INT)
PROTOCCALLSFSUB5(HUWFUN,huwfun,INT,INT,STRING,INT,STRING)
PROTOCCALLSFSUB3(HXI,hxi,INT,FLOAT,PINT)
PROTOCCALLSFSUB5(HXYIJ,hxyij,INT,FLOAT,FLOAT,PINT,PINT)
PROTOCCALLSFFUN1(LOGICAL,HEXIST,hexist,INT)
PROTOCCALLSFFUN2(FLOAT,HI,hi,INT,INT)
PROTOCCALLSFFUN2(FLOAT,HIE,hie,INT,INT)
PROTOCCALLSFFUN2(FLOAT,HIF,hif,INT,INT)
PROTOCCALLSFFUN3(FLOAT,HIJ,hij,INT,INT,INT)
PROTOCCALLSFFUN1(FLOAT,HMAX,hmax,INT)
PROTOCCALLSFFUN1(FLOAT,HMIN,hmin,INT)
PROTOCCALLSFFUN1(FLOAT,HRNDM1,hrndm1,INT)
PROTOCCALLSFFUN4(FLOAT,HSPFUN,hspfun,INT,FLOAT,INT,INT)
PROTOCCALLSFFUN4(FLOAT,HSTATI,hstati,INT,INT,STRING,INT)
PROTOCCALLSFFUN1(FLOAT,HSUM,hsum,INT)
PROTOCCALLSFFUN2(FLOAT,HX,hx,INT,FLOAT)
PROTOCCALLSFFUN2(FLOAT,HXE,hxe,INT,FLOAT)
PROTOCCALLSFFUN3(FLOAT,HXY,hxy,INT,FLOAT,FLOAT)

#if defined(vms) || defined(__vms)

PROTOCCALLSFFUN3(INT,HCREATEG,hcreateg,STRING,PINT,INT)
PROTOCCALLSFFUN3(INT,HMAPG,hmapg,STRING,PINT,PINT)

#else

PROTOCCALLSFSUB2(HLIMAP,hlimap,INT,STRING)

#endif
